//
// SkinnedDialog.h
//

#pragma once

/////////////////////////////////////////////////////////////////////////////

#include "SkinnedWndCompanionObj.h"
#include "resource.h"

class CSkinnedDialog : public CDialog
{
// Construction
public:
	CSkinnedDialog( UINT nIDTemplate, CWnd* pParentWnd = NULL, UINT nIDSkin = IDB_DEFAULTSKIN, COLORREF clrSkinBkgrd = RGB( 223, 248, 255 ) );
	~CSkinnedDialog ();

	BOOL		m_bProvideDefIcon;

// Protected Methods
protected:

	void GetClientRectInScreenCoords( CRect& rctClientRect )
	{
		if ( m_pswcoCompanionObj )
			m_pswcoCompanionObj->GetClientRectInScreenCoords( rctClientRect );
		else
			rctClientRect.SetRect( 0, 0, 0, 0 );
	}
	void GetMinTrackSize( long& lX, long& lY )
	{
		if ( m_pswcoCompanionObj )
			m_pswcoCompanionObj->GetMinTrackSize( lX, lY );
		else
		{
			lX = 0;
			lY = 0;
		}
	}
	void SetMinTrackSize( long lX, long lY )
	{
		if ( m_pswcoCompanionObj )
			m_pswcoCompanionObj->SetMinTrackSize( lX, lY );
	}

// Implementation
protected:

	UINT		m_nIDSkin;
	COLORREF	m_clrSkinBkgrd;

	CSkinnedWndCompanionObj* m_pswcoCompanionObj;

	// Generated message map functions
	//{{AFX_MSG(CImgDownloaderDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnNcPaint();
	afx_msg void OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg UINT OnNcHitTest(CPoint point);
	afx_msg BOOL OnNcActivate(BOOL bActive);
	afx_msg void OnNcLButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnNcLButtonUp(UINT nHitTest, CPoint point);
	afx_msg void OnNcRButtonDown(UINT nHitTest, CPoint point);
	afx_msg void OnNcRButtonUp(UINT nHitTest, CPoint point);
	afx_msg void OnLButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnLButtonUp( UINT nFlags, CPoint point );
	afx_msg void OnRButtonDown( UINT nFlags, CPoint point );
	afx_msg void OnRButtonUp( UINT nFlags, CPoint point );
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnNcMouseMove(UINT nHitTest, CPoint point);
	afx_msg BOOL OnSetCursor( CWnd* pWnd, UINT nHitTest, UINT message );
	afx_msg void OnInitMenu( CMenu* pMenu );
	afx_msg void OnLButtonDblClk( UINT nFlags, CPoint point );
	afx_msg void OnNcLButtonDblClk( UINT nHitTest, CPoint point );
	afx_msg void OnCaptureChanged( CWnd* pWnd );
	afx_msg void OnTimer( UINT_PTR nIDEvent );
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////

// Base Class Stubs
private:

	afx_msg BOOL OnSetCursor_CDIALOG( CWnd* pWnd, UINT nHitTest, UINT message ) { return CDialog::OnSetCursor( pWnd, nHitTest, message ); }
	afx_msg void OnNcLButtonDown_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcLButtonDown( nHitTest, point ); }
	afx_msg void OnNcLButtonUp_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcLButtonUp( nHitTest, point ); }
	afx_msg void OnNcRButtonDown_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcRButtonDown( nHitTest, point ); }
	afx_msg void OnNcRButtonUp_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcRButtonUp( nHitTest, point ); }
	afx_msg void OnLButtonDown_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnLButtonDown( nFlags, point ); }
	afx_msg void OnLButtonUp_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnLButtonUp( nFlags, point ); }
	afx_msg void OnRButtonDown_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnRButtonDown( nFlags, point ); }
	afx_msg void OnRButtonUp_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnRButtonUp( nFlags, point ); }
	afx_msg void OnMouseMove_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnMouseMove( nFlags, point ); }
	afx_msg void OnNcMouseMove_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcMouseMove( nHitTest, point ); }
	afx_msg void OnLButtonDblClk_CDIALOG( UINT nFlags, CPoint point ) { CDialog::OnLButtonDblClk( nFlags, point ); }
	afx_msg void OnNcLButtonDblClk_CDIALOG( UINT nHitTest, CPoint point ) { CDialog::OnNcLButtonDblClk( nHitTest, point ); }

friend class CSkinnedWndCompanionObj;

/////////////////////////////////////////////////////////////////////////////

	DECLARE_DYNAMIC( CSkinnedDialog )
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.
